/*
 * generated by Xtext 2.9.1
 */
package de.fhmuenster.masterthesis.generator

import de.fhmuenster.masterthesis.generator.mockdata.IsMock
import de.fhmuenster.masterthesis.generator.mockdata.ManualMock
import de.fhmuenster.masterthesis.generator.testdata.IsTestProgressCheck
import de.fhmuenster.masterthesis.generator.testdata.IsTeststep
import de.fhmuenster.masterthesis.generator.testdata.NotPassedCheck
import de.fhmuenster.masterthesis.generator.testdata.PassedCheck
import de.fhmuenster.masterthesis.generator.testdata.ProcessEndedCheck
import de.fhmuenster.masterthesis.generator.testdata.ProcessStartedCheck
import de.fhmuenster.masterthesis.generator.testdata.TestExternalTask
import de.fhmuenster.masterthesis.generator.testdata.TestProgressCheck
import de.fhmuenster.masterthesis.generator.testdata.TestStart
import de.fhmuenster.masterthesis.generator.testdata.TestTask
import de.fhmuenster.masterthesis.generator.testdata.Testcase
import de.fhmuenster.masterthesis.generator.testdata.VariableValuePair
import de.fhmuenster.masterthesis.generator.testdata.VariablesCheck
import de.fhmuenster.masterthesis.generator.utils.TestgeneratorClassUtils
import de.fhmuenster.masterthesis.testgeneratorDSL.BPMNDiagram
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariable
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableDeclaration
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableNotEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.BusinessRuleTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.DelegateMock
import de.fhmuenster.masterthesis.testgeneratorDSL.DelegateServiceTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.EndCheck
import de.fhmuenster.masterthesis.testgeneratorDSL.EndFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock
import de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.Flow
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElementReference
import de.fhmuenster.masterthesis.testgeneratorDSL.GatewayFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariable
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableDeclaration
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableNotEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.ManualTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.MockReference
import de.fhmuenster.masterthesis.testgeneratorDSL.ScriptTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.SequenceFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.StartFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariable
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableDeclaration
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableNotEquals
import de.fhmuenster.masterthesis.testgeneratorDSL.Test
import de.fhmuenster.masterthesis.testgeneratorDSL.UserTaskFlowElement
import de.fhmuenster.masterthesis.testgeneratorDSL.VariableDeclaration
import de.fhmuenster.masterthesis.testgeneratorDSL.VariableDeclarations
import java.util.ArrayList
import java.util.HashMap
import java.util.Iterator
import java.util.List
import java.util.Map
import java.util.stream.Collectors
import java.util.stream.Stream
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.AbstractGenerator
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.xtext.generator.IGeneratorContext

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
class TestgeneratorDSLGenerator extends AbstractGenerator {

	String testcollectionPackageName = "";
	String testcollectionFilePath = "";
	StringBuilder codegeneratorTests;

	HashMap<String, HashMap<String, Object>> globalTaskVariables;
	Map<String, String> globalExternalTopicsMap;
	Map<String, BPMNGenDiagram> diagramMap;
	Map<String, BPMNGenFlow> flowMap;
	List<BPMNGenFlowElement> flowElements;
	List<de.fhmuenster.masterthesis.generator.mockdata.DelegateMock> delegateMocks;
	List<de.fhmuenster.masterthesis.generator.mockdata.ExternalServiceMock> externalServiceMocks;

	FlowElementDefinitionGenerator flowElementDefinitionGenerator;

	static final String CARRIAGE_RETURN = "\r\n";
	static final String FILE_EXTENSION = ".bpmn-testgen";
	static final String FILE_NAME = "%s.java";
	static final String TEST_UTILS_FILENAME = "TestUtils";
	static final String CLASS_DECLARATION = "public class %s {";
	static final String VARIABLE_DECLARATION = "\tprivate static final String %s = \"%s\";";
	static final String TESTCASE_DEPLOYMENT = "\t@Deployment(resources = {%s})";
	static final String TESTCASE_SINGLE_DEPLOYMENT = "\"%s\"";
	static final String TESTCASE_METHOD = "\tpublic void %s() {";
	static final String EXTERNALSERVICEMOCKPROVIDER_NAME = "ExternalServiceMockProvider";
	static final String EXTERNALSERVICEMOCKPROVIDER_FILENAME = EXTERNALSERVICEMOCKPROVIDER_NAME + ".java";

	override void doGenerate(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) {
		codegeneratorTests = new StringBuilder();

		globalExternalTopicsMap = new HashMap();
		globalTaskVariables = new HashMap();
		diagramMap = new HashMap();
		flowMap = new HashMap();
		flowElements = new ArrayList();
		delegateMocks = new ArrayList();
		externalServiceMocks = new ArrayList();

		// Prepare Mocks first, because flow elements needs access to them
		prepareDelegateMocks(resource);
		prepareExternalServiceMocks(resource);
		prepareGlobalExternalTopics(resource);
		prepareGlobalTaskVariables(resource);
		prepareBPMNDiagrams(resource);
		prepareBPMNFlows(resource);
		prepareFlowElements(resource);

		createMockClasses(fsa);
		createFlowElementDefinitionClasses(fsa);
		createUtilClasses(fsa);
		createTestcollection(fsa, resource);
	}

	def createMockClasses(IFileSystemAccess2 fsa) {
		val ExternalServiceMockGenerator externalMockGenerator = new ExternalServiceMockGenerator(externalServiceMocks,
			testcollectionPackageName);
		externalMockGenerator.generateMock();
		fsa.generateFile(testcollectionFilePath + "//" + EXTERNALSERVICEMOCKPROVIDER_FILENAME,
			externalMockGenerator.getMockCode());
	}

	def createFlowElementDefinitionClasses(IFileSystemAccess2 fsa) {
		flowElementDefinitionGenerator = new FlowElementDefinitionGenerator(flowElements, testcollectionPackageName);
		flowElementDefinitionGenerator.generateCode();

		val String filenameUserTasks = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.USER_TASK_NAME);
		fsa.generateFile(filenameUserTasks, flowElementDefinitionGenerator.getUserTaskCode());

		val String filenameManualTasks = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.MANUAL_TASK_NAME);
		fsa.generateFile(filenameManualTasks, flowElementDefinitionGenerator.getManualTaskCode());

		val String filenameScriptTasks = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.SCRIPT_TASK_NAME);
		fsa.generateFile(filenameScriptTasks, flowElementDefinitionGenerator.getScriptTaskCode());

		val String filenameServiceTasks = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.SERVICE_TASK_NAME);
		fsa.generateFile(filenameServiceTasks, flowElementDefinitionGenerator.getServiceTaskCode());

		val String filenameBusinessRuleTasks = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.BUSINESS_RULE_NAME);
		fsa.generateFile(filenameBusinessRuleTasks, flowElementDefinitionGenerator.getBusinessRuleTaskCode());

		val String filenameGateways = String.format(testcollectionFilePath + "//" + FILE_NAME,
			NameProvider.GATEWAYS_NAME);
		fsa.generateFile(filenameGateways, flowElementDefinitionGenerator.getGatewayCode());

		val String filenameEvents = String.format(testcollectionFilePath + "//" + FILE_NAME, NameProvider.EVENTS_NAME);
		fsa.generateFile(filenameEvents, flowElementDefinitionGenerator.getEventCode());
	}
	
	def createUtilClasses(IFileSystemAccess2 fsa) {
		val TestUtilsGenerator generator = new TestUtilsGenerator(testcollectionPackageName);
		generator.generateUtils();
		
		val String filenameUtils = String.format(testcollectionFilePath + "//" + FILE_NAME, TEST_UTILS_FILENAME);
		fsa.generateFile(filenameUtils, generator.getUtilsCode());
	}

	def createTestcollection(IFileSystemAccess2 fsa, Resource resource) {
		val List<String> segments = resource.getURI().segmentsList;
		val String filenamePrefix = segments.get(segments.size() - 1).replace(FILE_EXTENSION, "");

		generateTestcollection(resource, filenamePrefix);
		val testContent = codegeneratorTests.toString();

		val String filenameTestcollection = String.format(testcollectionFilePath + "//" + FILE_NAME, filenamePrefix);
		fsa.generateFile(filenameTestcollection, testContent);
	}

	def generateTestcollection(Resource resource, String testcollectionName) {
		addPackageDeclaration(testcollectionPackageName, codegeneratorTests);
		addSeparatorLine();

		addAssertImports();
		addSeparatorLine();

		addImports();
		addSeparatorLine();

		addClassHeader(testcollectionName, codegeneratorTests);
		addSeparatorLine();

		addRule();
		addSeparatorLine();

		addVariableDeclarations(getVariables(resource));
		addSeparatorLine();

		addLogging();
		addSeparatorLine();

		addSetup();

		addTests(getTests(resource));

		addClassClosing(codegeneratorTests);
	}

	def addPackageDeclaration(String packageName, StringBuilder builder) {
		appendLine(NameProvider.getPackageDeclaration(packageName), builder);
	}

	def addAssertImports() {
		appendLine("import static org.camunda.bpm.engine.test.assertions.ProcessEngineTests.*;");
		appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.complete;");
		appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.runtimeService;");
		appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.task;");
		appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.withVariables;");
		appendLine("import static org.assertj.core.api.Assertions.entry;");
		appendLine(String.format("import static %s.TestUtils.*;", testcollectionPackageName));
	}

	def addImports() {
		appendLine("import org.apache.ibatis.logging.LogFactory;");
		appendLine("import org.camunda.bpm.engine.runtime.ProcessInstance;");
		appendLine("import org.camunda.bpm.engine.test.Deployment;");
		appendLine("import org.camunda.bpm.engine.test.ProcessEngineRule;");
		appendLine("import org.camunda.bpm.engine.externaltask.LockedExternalTask;");

		if (!delegateMocks.isEmpty()) {
			appendLine("import org.camunda.bpm.engine.test.mock.Mocks;");

			val List<String> packages = Stream.concat(
				delegateMocks.stream() //
				.flatMap[manualMocks.stream()] //
				.map[packageName], //
				delegateMocks.stream() //
				.map[packageName] //
			) //
			.distinct() //
			.filter[packageName|packageName.replace(testcollectionPackageName + ".", "").contains(("."))].collect(
				Collectors.toList()); //
			packages //
			.forEach[packageName|appendLine(String.format("import %s;", packageName))]; //
		}

		appendLine(
			"import org.camunda.bpm.extension.process_test_coverage.junit.rules.TestCoverageProcessEngineRuleBuilder;");
		appendLine("import org.junit.Before;");
		appendLine("import org.junit.ClassRule;");
		appendLine("import org.junit.Rule;");
		appendLine("import java.util.List;");
		appendLine("import java.util.Map;");
		appendLine("import org.junit.jupiter.api.Test;");
		appendLine("import org.junit.jupiter.api.TestMethodOrder;");
		appendLine("import org.junit.jupiter.api.extension.ExtendWith;");
		appendLine("import org.junit.jupiter.api.Order;");
		appendLine("import org.junit.jupiter.api.MethodOrderer;");
		appendLine("import org.camunda.bpm.extension.junit5.test.ProcessEngineExtension;");
		
	}

	def addClassHeader(String className, StringBuilder builder) {
		appendLine("@TestMethodOrder(MethodOrderer.OrderAnnotation.class)");
		appendLine("@ExtendWith(ProcessEngineExtension.class)");
		appendLine(String.format(CLASS_DECLARATION, className), builder);
	}

	def addRule() {
		appendLine("\t@ClassRule");
		appendLine("\t@Rule");
		appendLine("\tpublic static ProcessEngineRule rule = TestCoverageProcessEngineRuleBuilder.create().build();");
	}

	def addVariableDeclarations(List<String> testvariables) {
		testvariables.forEach[addVariableDeclaration()];
	}

	def addVariableDeclaration(String variableName) {
		appendLine(
			String.format(VARIABLE_DECLARATION, NameProvider.getStaticFinalVariableName(variableName), variableName));
	}

	def addLogging() {
		appendLine("\tstatic {");
		appendLine("\t\tLogFactory.useSlf4jLogging();");
		appendLine("\t}");
	}

	def addSetup() {
		appendLine("\t@Before");
		appendLine("\tpublic void setup() {");
		appendLine("\t\tinit(rule.getProcessEngine());");

		if (!delegateMocks.isEmpty()) {
			addSeparatorLine();
			addDelegateMockSetup();
		}

		appendLine("\t}");
	}

	def addDelegateMockSetup() {
		val Map<String, String> mocksToRegister = new HashMap();

		for (de.fhmuenster.masterthesis.generator.mockdata.DelegateMock mock : delegateMocks) {
			val Map<String, String> manualMocks = new HashMap();

			for (ManualMock manualMock : mock.getManualMocks()) {
				val String manualMockClassName = manualMock.getClassName();
				val String manualMockVariableName = TestgeneratorClassUtils.getVariableName(manualMockClassName);
				val String manualMockSetter = manualMock.getSetter();

				appendLine(
					String.format("\t\t%s %s = new %s();", manualMockClassName, manualMockVariableName,
						manualMockClassName));

				manualMocks.put(manualMockVariableName, manualMockSetter);
			}

			addSeparatorLine();

			val String delegateClassName = mock.getDelegateClassName();
			val String variableName = TestgeneratorClassUtils.getVariableName(delegateClassName);
			val String registrationName = mock.getRegistrationName();

			appendLine(String.format("\t\t%s %s = new %s();", delegateClassName, variableName, delegateClassName));
			for (Map.Entry<String, String> entry : manualMocks.entrySet()) {
				appendLine(String.format("\t\t%s.%s(%s);", variableName, entry.getValue(), entry.getKey()));
			}

			mocksToRegister.put(variableName, registrationName);
		}

		addSeparatorLine();

		for (Map.Entry<String, String> entry : mocksToRegister.entrySet()) {
			appendLine(String.format("\t\tMocks.register(\"%s\", %s);", entry.getValue(), entry.getKey()));
		}
	}

	def addTests(List<Test> testcases) {
		for (Test testcase : testcases) {
			addSeparatorLine();
			addTest(testcase);
		}
	}

	def addTest(Test test) {
		val BPMNGenTestcase bpmnTestcase = getBPMNTestcase(test);
		val BPMNGenDiagram bpmnDiagram = bpmnTestcase.getFlow().getBpmnDiagram();
		val BPMNTestcollectionCreator c = new BPMNTestcollectionCreator().withProcessIntanceKey(
			bpmnDiagram.getProcessInstanceKey());
		val Testcase testcase = c.build(bpmnTestcase);

		appendLine("\t@Test");
		appendLine("\t@Order(" + test.getOrder() + (")"));
		
		addDeployment(bpmnDiagram.getDeployments());

		appendLine(String.format(TESTCASE_METHOD, test.getName()));

		addSeparatorLine();

		var int variableSnapshotCounter = 0;
		var int externalTaskCounter = 0;
		for (IsTeststep teststep : testcase.getTeststeps()) {
			if (teststep instanceof TestStart) {
				addProcessStart(teststep);
			}

			if (teststep instanceof TestProgressCheck) {
				addProgressCheck(teststep);
			}

			if (teststep instanceof TestTask) {
				addTask(teststep);
			}

			if (teststep instanceof TestExternalTask) {
				addExternalTask(teststep, variableSnapshotCounter, externalTaskCounter);
				variableSnapshotCounter++;
				externalTaskCounter++;
			}

			addSeparatorLine();
		}

		appendLine("\t}");
	}

	def addDeployment(List<String> deployments) {
		val List<String> deploymentList = new ArrayList();
		for (String deployment : deployments) {
			deploymentList.add(String.format(TESTCASE_SINGLE_DEPLOYMENT, deployment.replace("\\", "\\\\")));
		}

		val String joinedDeployments = String.join(", ", deploymentList);
		appendLine(String.format(TESTCASE_DEPLOYMENT, joinedDeployments));
	}

	def addProcessStart(TestStart testStart) {
		appendLine("\t\tProcessInstance processInstance = runtimeService() //");
		
		val String joinedVariables = variables(testStart.getVariableKeyValues());
		if (joinedVariables === null) {
			appendLine(String.format("\t\t\t.startProcessInstanceByKey(\"%s\"); //",
				testStart.getProcessInstanceKey()));
		} else {
			appendLine(
				String.format("\t\t\t.startProcessInstanceByKey(\"%s\", withVariables(%s)); //",
					testStart.getProcessInstanceKey(), joinedVariables));
		}
	}

	def addProgressCheck(TestProgressCheck progressCheck) {
		appendLine("\t\tassertThat(processInstance) //");

		val Iterator<IsTestProgressCheck> progressChecksIterator = progressCheck.getProgressChecks().iterator();
		while (progressChecksIterator.hasNext()) {
			val IsTestProgressCheck check = progressChecksIterator.next();

			if (check instanceof PassedCheck) {
				addAssertPassed(check);
				appendLine(codeformatLine(!progressChecksIterator.hasNext()));
			}

			if (check instanceof NotPassedCheck) {
//				addAssertNotPassed(check);
			}

			if (check instanceof ProcessStartedCheck) {
				addAssertStarted(check);
				appendLine(codeformatLine(!progressChecksIterator.hasNext()));
			}

			if (check instanceof VariablesCheck) {
				addAssertVariables(check);
				appendLine(codeformatLine(!progressChecksIterator.hasNext()));
			}

			if (check instanceof ProcessEndedCheck) {
				addAssertEnded(check);
				appendLine(codeformatLine(!progressChecksIterator.hasNext()));
			}

			
		}
	}

	def addAssertPassed(PassedCheck passedCheck) {
		append(
			String.format("\t\t\t.hasPassed(%s)",
				getFlowElementReference(passedCheck.getFlowElementType(), passedCheck.getTaskId())));
	}

	def addAssertNotPassed(NotPassedCheck notPassedCheck) {
		append(
			String.format("\t\t\t.hasNotPassed(%s)",
				getFlowElementReference(notPassedCheck.getFlowElementType(), notPassedCheck.getTaskId())));
	}

	def addAssertStarted(ProcessStartedCheck startedCheck) {
		if (startedCheck.isStarted()) {
			append("\t\t\t.isStarted()");
		}
	}

	def addAssertEnded(ProcessEndedCheck endedCheck) {
		if (endedCheck.isEnded()) {
			append("\t\t\t.isEnded()");
		} else {
			append("\t\t\t.isNotEnded()");
		}
	}

	def addAssertVariables(VariablesCheck variablesCheck) {
		val List<VariableValuePair> checksEquals = variablesCheck.getVariableEqualsChecks();
		val List<VariableValuePair> checksNotEquals = variablesCheck.getVariableNotEqualsChecks();

		if(!checksEquals.isEmpty() || !checksNotEquals.isEmpty()) {
			append("\t\t\t.variables()");
			appendLine(codeformatLine(false));
		}

		if (!checksEquals.isEmpty()) {
			val String entries = entries(checksEquals);
			append(String.format("\t\t\t\t.contains(%s)", entries));

			if (!checksNotEquals.isEmpty()) {
				appendLine(codeformatLine(false));
			}
		}

		if (!checksNotEquals.isEmpty()) {
			val String entries = entries(checksNotEquals);
			append(String.format("\t\t\t\t.doesNotContain(%s)", entries));
		}
	}

	def String entries(List<VariableValuePair> variableValuePairs) {
		val List<String> entries = new ArrayList();

		for (VariableValuePair pair : variableValuePairs) {
			entries.add(String.format("entry(%s, %s)", NameProvider.getStaticFinalVariableName(pair.getVariable()), variable(pair.getValue())));
		}

		return String.join(", ", entries);
	}

	def addTask(TestTask task) {
		val HashMap<String, Object> variables = task.getVariableKeyValues();
		val String joinedVariables = variables(variables);

		val taskName = getFlowElementReference(FlowElementType.USER_TASK, task.getName());
		if (joinedVariables === null) {
			appendLine(String.format("\t\tcomplete(task(%s));", taskName));
		} else {
			appendLine(String.format("\t\tcomplete(task(%s), withVariables(%s));", taskName, joinedVariables));
		}
	}

	def addExternalTask(TestExternalTask task, int variableSnapshotCounter, int externalTaskCounter) {
		val taskName = getFlowElementReference(FlowElementType.SERVICE_TASK_EXTERNAL, task.getName());
		val HashMap<String, Object> hardcodedVariableValues = task.getHardcodedVariableValues();
		val String externalMockName = task.getExternalMockName() != null ? task.getExternalMockName() : "";

		appendLine(
			String.format("\t\tMap<String, Object> variableSnapshot%s = runtimeService() //", variableSnapshotCounter));
		appendLine("\t\t\t.getVariables(processInstance.getId()); //");

		hardcodedVariableValues.entrySet().stream() //
			.forEach( entry | {
				val String variableName = NameProvider.getStaticFinalVariableName(entry.getKey);
				val String variableValue = variable(entry.getValue());
				appendLine(String.format("\t\tvariableSnapshot%s.put(%s, %s);", variableSnapshotCounter, variableName, variableValue))
			}
		);

		if(externalTaskCounter == 0) {
			appendLine(String.format("\t\tList<LockedExternalTask> lockedTasks%s = lockTasks(\"%s\");", externalTaskCounter, task.getTopic()));
		} else {
			appendLine(String.format("\t\tList<LockedExternalTask> lockedTasks%s = lockTasks(lockedTasks%s, \"%s\");", externalTaskCounter, (externalTaskCounter - 1), task.getTopic()));
		}
		appendLine(
			String.format("\t\tcomplete(getLockedTask(lockedTasks%s, %s), ExternalServiceMockProvider.%s(variableSnapshot%s));",
				externalTaskCounter, taskName, externalMockName, variableSnapshotCounter));
	}

	def addClassClosing(StringBuilder builder) {
		appendLine("}", builder);
	}

	def append(String text) {
		codegeneratorTests.append(text);
	}

	def appendLine(String line) {
		codegeneratorTests.append(line);
		codegeneratorTests.append(CARRIAGE_RETURN);
	}

	def addSeparatorLine() {
		codegeneratorTests.append(CARRIAGE_RETURN);
	}

	def append(String text, StringBuilder builder) {
		builder.append(text);
	}

	def appendLine(String line, StringBuilder builder) {
		builder.append(line);
		builder.append(CARRIAGE_RETURN);
	}

	def addSeparatorLine(StringBuilder builder) {
		builder.append(CARRIAGE_RETURN);
	}

	def String codeformatLine(boolean lastLine) {
		if (lastLine) {
			return "; //";
		} else {
			return " //";
		}
	}

	def String variables(HashMap<String, Object> variables) {
		val List<String> variableList = variables.entrySet().stream() //
		.map(entry|String.join(", ", entry.getKey(), variable(entry.getValue()))) //
		.collect(Collectors.toList()); //
		if (!variableList.isEmpty()) {
			return String.join(", ", variableList);
		}

		return null;
	}

	def String variable(Object variable) {
		if (variable instanceof String) {
			return "\"" + variable + "\"";
		}
		return variable.toString();
	}

	def List<String> getVariables(Resource resource) {
		val List<String> stringVariables = resource.allContents.filter(typeof(StringVariable)).map[name].toList

		val List<String> intVariables = resource.allContents.filter(typeof(IntVariable)).map[name].toList

		val List<String> booleanVariables = resource.allContents.filter(typeof(BooleanVariable)).map[name].toList

		val List<String> allVariables = new ArrayList();
		allVariables.addAll(stringVariables);
		allVariables.addAll(intVariables);
		allVariables.addAll(booleanVariables);

		return allVariables;
	}

	def String getFlowElementReference(FlowElementType flowElementType, String flowElement) {
		var String clazz = "";

		if (FlowElementType.USER_TASK.equals(flowElementType)) {
			clazz = NameProvider.USER_TASK_NAME;
		} else if (FlowElementType.MANUAL_TASK.equals(flowElementType)) {
			clazz = NameProvider.MANUAL_TASK_NAME;
		} else if (FlowElementType.SCRIPT_TASK.equals(flowElementType)) {
			clazz = NameProvider.SCRIPT_TASK_NAME;
		} else if (FlowElementType.SERVICE_TASK_DELEGATE.equals(flowElementType)) {
			clazz = NameProvider.SERVICE_TASK_NAME;
		} else if (FlowElementType.SERVICE_TASK_EXTERNAL.equals(flowElementType)) {
			clazz = NameProvider.SERVICE_TASK_NAME;
		} else if (FlowElementType.BUSINESS_RULE_TASK.equals(flowElementType)) {
			clazz = NameProvider.BUSINESS_RULE_NAME;
		} else if (FlowElementType.GATEWAY.equals(flowElementType)) {
			clazz = NameProvider.GATEWAYS_NAME;
		} else if (FlowElementType.START_EVENT.equals(flowElementType)) {
			clazz = NameProvider.EVENTS_NAME;
		} else if (FlowElementType.END_EVENT.equals(flowElementType)) {
			clazz = NameProvider.EVENTS_NAME;
		}

		return clazz + "." + NameProvider.getStaticFinalFlowElementName(flowElementType, flowElement);
	}

	def List<Test> getTests(Resource resource) {
		return resource.allContents.filter(typeof(Test)).toList
	}

	def prepareBPMNDiagrams(Resource resource) {
		val List<BPMNDiagram> diagrams = resource.allContents //
		.filter(typeof(BPMNDiagram)) //
		.toList; //
		for (BPMNDiagram diagram : diagrams) {
			val BPMNGenDiagram bpmnDiagram = new BPMNGenDiagram();
			testcollectionPackageName = diagram.getTestpackage();
			testcollectionFilePath = diagram.getTestpackage().replace(".", "//");
			bpmnDiagram.setTestpackage(diagram.getTestpackage());
			bpmnDiagram.setBpmn(diagram.getBpmn());
			bpmnDiagram.setProcessInstanceKey(diagram.getKey());
			bpmnDiagram.setDmns(diagram.getDmn());

			diagramMap.put(diagram.getName(), bpmnDiagram);
		}
	}

	def prepareBPMNFlows(Resource resource) {
		val List<Flow> flows = resource.allContents.filter(typeof(Flow)).toList;

		for (Flow f : flows) {
			val List<BPMNGenFlowElement> flowElements = new ArrayList();
			val String bpmnName = f.getBpmnReference().getRef().getName();
			val BPMNGenDiagram diagram = diagramMap.get(bpmnName);

			for (FlowElementReference r : f.getInclElements()) {
				val BPMNGenFlowElement flowElement = createBPMNGenFlowElement(r.getRef());
				flowElements.add(flowElement);
			}

			val List<BPMNGenFlowElement> exclusiveFlowElements = new ArrayList();
			for (FlowElementReference r : f.getExclElements()) {
				val BPMNGenFlowElement flowElement = createBPMNGenFlowElement(r.getRef());
				exclusiveFlowElements.add(flowElement);
			}

			val BPMNGenFlow flow = new BPMNGenFlow();
			flow.setBpmnDiagram(diagram);
			flow.setName(f.getName());
			flow.setFlowElements(flowElements);
			flow.setExclusiveFlowElements(exclusiveFlowElements);

			flowMap.put(f.getName(), flow);
		}
	}

	def prepareFlowElements(Resource resource) {
		val List<FlowElement> flowElements = resource.allContents.filter(typeof(FlowElement)).toList;

		for (FlowElement f : flowElements) {
			val FlowElementType type = getFlowElementType(f);

			if (isDeclarationType(type)) {
				val BPMNGenFlowElement flowElement = createBPMNGenFlowElement(f);
				this.flowElements.add(flowElement);
			}
		}

	}

	def prepareDelegateMocks(Resource resource) {
		val dslDelegateMocks = resource.allContents.filter(typeof(DelegateMock)).toList;

		val MockCreator creator = new MockCreator();
		delegateMocks = creator.createDelegationMock(dslDelegateMocks);
	}

	def prepareExternalServiceMocks(Resource resource) {
		val dslExternalServiceMocks = resource.allContents.filter(typeof(ExternalServiceMock)).toList;

		val MockCreator creator = new MockCreator();
		externalServiceMocks = creator.createExternalServiceMock(dslExternalServiceMocks);
	}

	def BPMNGenTestcase getBPMNTestcase(Test test) {
		val BPMNGenFlow flow = flowMap.get(test.flowReference.ref.name);

		val BPMNGenTestcase bpmnTestcase = new BPMNGenTestcase();
		bpmnTestcase.setName(test.getName());
		bpmnTestcase.setFlow(flow);
		bpmnTestcase.setGlobalTaskVariableMap(globalTaskVariables);
		bpmnTestcase.setGlobalExternalTopicsMap(globalExternalTopicsMap);

		for (MockReference mockRef : test.getMocks()) {
			val String mockName = mockRef.getRef().getName();
			val IsMock mock = getMockByName(mockName);
			bpmnTestcase.addMock(mock);
		}

		val List<TaskVariables> taskVariables = new ArrayList();
		for (VariableDeclarations vd : test.getDeclarations()) {
			val String task = vd.getTaskReference().getRef().getName();
			
			addTaskVariables(taskVariables, vd.getVariables(), task);			
		}
		bpmnTestcase.setTaskVariableMap(taskVariables);

		if (test.getEndCheck() != null) {
			for (EndCheck endCheck : test.getEndCheck().getEndChecks()) {
				if (endCheck instanceof StringVariableEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.EQUALS, endCheck.getValue());
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}
				if (endCheck instanceof IntVariableEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.EQUALS, endCheck.getValue());
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}
				if (endCheck instanceof BooleanVariableEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.EQUALS,
						Boolean.parseBoolean(endCheck.getValue().getName()));
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}

				if (endCheck instanceof StringVariableNotEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.NOT_EQUALS, endCheck.getValue());
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}
				if (endCheck instanceof IntVariableNotEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.NOT_EQUALS, endCheck.getValue());
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}
				if (endCheck instanceof BooleanVariableNotEquals) {
					val VariableCheck check = new VariableCheck(VariableCheckOperator.NOT_EQUALS,
						Boolean.parseBoolean(endCheck.getValue().getName()));
					bpmnTestcase.putEndCheckVariable(endCheck.getKey().getName(), check);
				}
			}
		}

		return bpmnTestcase;
	}

	def FlowElementType getFlowElementType(FlowElement flowElement) {
		if (flowElement instanceof StartFlowElement) {
			return FlowElementType.START_EVENT;
		}

		if (flowElement instanceof EndFlowElement) {
			return FlowElementType.END_EVENT;
		}

		if (flowElement instanceof UserTaskFlowElement) {
			return FlowElementType.USER_TASK;
		}

		if (flowElement instanceof ManualTaskFlowElement) {
			return FlowElementType.MANUAL_TASK;
		}

		if (flowElement instanceof ScriptTaskFlowElement) {
			return FlowElementType.SCRIPT_TASK;
		}

		if (flowElement instanceof DelegateServiceTaskFlowElement) {
			return FlowElementType.SERVICE_TASK_DELEGATE;
		}

		if (flowElement instanceof ExternalServiceTaskFlowElement) {
			return FlowElementType.SERVICE_TASK_EXTERNAL;
		}

		if (flowElement instanceof BusinessRuleTaskFlowElement) {
			return FlowElementType.BUSINESS_RULE_TASK;
		}

		if (flowElement instanceof GatewayFlowElement) {
			return FlowElementType.GATEWAY;
		}

		if (flowElement instanceof SequenceFlowElement) {
			return FlowElementType.SEQUENCE_FLOW;
		}

		return null;
	}

	def BPMNGenFlowElement createBPMNGenFlowElement(FlowElement f) {
		val BPMNGenFlowElement flowElement = new BPMNGenFlowElement();
		val flowElementType = getFlowElementType(f)

		flowElement.setId(f.getName())
		flowElement.setType(flowElementType);

		return flowElement;
	}

	def IsMock getMockByName(String mockName) {
		for (de.fhmuenster.masterthesis.generator.mockdata.ExternalServiceMock externalMock : externalServiceMocks) {
			if (externalMock.getName().equals(mockName)) {
				return externalMock;
			}
		}

		for (de.fhmuenster.masterthesis.generator.mockdata.DelegateMock delegateMock : delegateMocks) {
			if (delegateMock.getName().equals(mockName)) {
				return delegateMock;
			}
		}

		return null;
	}

	def boolean isDeclarationType(FlowElementType type) {
		return !FlowElementType.SEQUENCE_FLOW.equals(type);
	}

	def void prepareGlobalExternalTopics(Resource resource) {
		val List<ExternalServiceTaskFlowElement> externalServiceTasks = resource.allContents.filter(
			typeof(ExternalServiceTaskFlowElement)).toList;
			
		for (ExternalServiceTaskFlowElement externalServiceTask : externalServiceTasks) {
			val String externalTopicName = externalServiceTask.getExternalTopic().getRef().getName();
			globalExternalTopicsMap.put(externalServiceTask.getName(), externalTopicName);
		}
	}

	def void prepareGlobalTaskVariables(Resource resource) {
		val List<ExternalServiceTaskFlowElement> externalServiceTasks = resource.allContents.filter(
			typeof(ExternalServiceTaskFlowElement)).toList;

		for (ExternalServiceTaskFlowElement externalServiceTask : externalServiceTasks) {
			val String task = externalServiceTask.getName();
			val List<VariableDeclaration> declarations = externalServiceTask.getHardcodedInputs();
			addGlobalTaskVariables(globalTaskVariables, declarations, task);
		}
	}

	def addTaskVariables(
		List<TaskVariables> taskVariables, List<VariableDeclaration> declarations, String task) {
		
		val HashMap<String, Object> variableMap = new HashMap();
		for (VariableDeclaration v : declarations) {
			if (v instanceof StringVariableDeclaration) {
				putTaskVariable(variableMap, v.getKey().getName(), v.getValue());
			}

			if (v instanceof IntVariableDeclaration) {
				putTaskVariable(variableMap, v.getKey().getName(), v.getValue());
			}

			if (v instanceof BooleanVariableDeclaration) {
				putTaskVariable(variableMap, v.getKey().getName(),
					Boolean.parseBoolean(v.getValue().getName()));
			}
		}
		
		val TaskVariables taskVariablesObj = new TaskVariables();
		taskVariablesObj.setTask(task);
		taskVariablesObj.setVariables(variableMap);
		
		taskVariables.add(taskVariablesObj);
	}

	def void putTaskVariable(HashMap<String, Object> variableMap, String variableKey,
		Object variableValue) {
		variableMap.put(variableKey, variableValue);
	}
	
	def HashMap<String, HashMap<String, Object>> addGlobalTaskVariables(
		HashMap<String, HashMap<String, Object>> taskVariables, List<VariableDeclaration> declarations, String task) {
		for (VariableDeclaration v : declarations) {
			if (v instanceof StringVariableDeclaration) {
				putGlobalTaskVariable(taskVariables, task, v.getKey().getName(), v.getValue());
			}

			if (v instanceof IntVariableDeclaration) {
				putGlobalTaskVariable(taskVariables, task, v.getKey().getName(), v.getValue());
			}

			if (v instanceof BooleanVariableDeclaration) {
				putGlobalTaskVariable(taskVariables, task, v.getKey().getName(),
					Boolean.parseBoolean(v.getValue().getName()));
			}
		}
	}

	def void putGlobalTaskVariable(HashMap<String, HashMap<String, Object>> taskVariableMap, String task, String variableKey,
		Object variableValue) {
		val HashMap<String, Object> taskVariables = taskVariableMap.getOrDefault(task, new HashMap());
		taskVariables.put(variableKey, variableValue);
		taskVariableMap.put(task, taskVariables);
	}
	
}
